## pyml 20190626

=== Makefile ===
PREFIX := /usr/local
OCAMLFIND := ocamlfind
INSTALL := install
INSTALL_PROGRAM := $(INSTALL)
bindir := $(PREFIX)/bin

HAVE_OCAMLFIND := $(shell \
	if $(OCAMLFIND) query -help >/dev/null 2>&1; then \
		echo yes; \
	else \
		echo no; \
	fi \
)

HAVE_UTOP := $(shell \
	if [ "$(HAVE_OCAMLFIND)" = no ]; then \
		echo no; \
	elif $(OCAMLFIND) query utop >/dev/null 2>&1; then \
		echo yes; \
	else \
		echo no; \
	fi \
)

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(HAVE_OCAMLFIND),no)
	OCAMLC := $(OCAMLFIND) ocamlc
	ifneq ($(HAVE_OCAMLOPT),no)
		OCAMLOPTEXE := $(OCAMLFIND) ocamlopt
	endif
	OCAMLMKLIB := $(OCAMLFIND) ocamlmklib
	OCAMLMKTOP := $(OCAMLFIND) ocamlmktop
	OCAMLDEP := $(OCAMLFIND) ocamldep
	OCAMLDOC := $(OCAMLFIND) ocamldoc
	STDCOMPAT := $(shell $(OCAMLFIND) query stdcompat)
        OCAMLCFLAGS := -package stdcompat
        OCAMLLDFLAGS := -linkpkg
	OCAMLBYTECODELIBS := -package unix,stdcompat
	OCAMLBYTECODELIBSNUMPY := -package unix,stdcompat,bigarray
	OCAMLNATIVELIBS := -package unix,stdcompat
	OCAMLNATIVELIBSNUMPY := -package unix,stdcompat,bigarray
else
	OCAMLC := $(shell \
		if ocamlc.opt -version >/dev/null 2>&1; then \
			echo ocamlc.opt; \
		elif ocamlc -version >/dev/null 2>&1; then \
			echo ocamlc; \
		fi \
	)
	ifeq ($(OCAMLC),)
$(error There is no OCaml compiler available in path)
	endif
	ifneq ($(HAVE_OCAMLOPT),no)
		OCAMLOPTEXE := $(shell \
			if ocamlopt.opt -version >/dev/null 2>&1; then \
				echo ocamlopt.opt; \
			elif ocamlopt -version >/dev/null 2>&1; then \
				echo ocamlopt; \
			fi \
		)
	endif
	OCAMLMKLIB := ocamlmklib
	OCAMLMKTOP := ocamlmktop
	OCAMLDEP := ocamldep
	OCAMLDOC := ocamldoc
	STDCOMPAT := .
        OCAMLCFLAGS :=
        OCAMLLDFLAGS :=
	OCAMLBYTECODELIBS := unix.cma stdcompat.cma
	OCAMLBYTECODELIBSNUMPY := unix.cma stdcompat.cma bigarray.cma
	OCAMLNATIVELIBS := unix.cmxa stdcompat.cmxa
	OCAMLNATIVELIBSNUMPY := unix.cmxa stdcompat.cmxa bigarray.cmxa
endif

ifeq ($(wildcard $(STDCOMPAT)/stdcompat.cma),)
$(error stdcompat module not found: please specify the path with STDCOMPAT=...)
endif

OCAMLVERSION := $(shell $(OCAMLC) -version)
endif

ifeq ($(HAVE_UTOP),yes)
	PYMLUTOP := pymlutop
else
	PYMLUTOP :=
endif

ifeq ($(OCAMLOPTEXE),)
	OCAMLOPT = $(error There is no optimizing OCaml compiler available)
	OCAMLCOPT := $(OCAMLC)
	CMOX := cmo
	CMAX := cma
	ALLOPT :=
	TESTSOPT :=
	OCAMLPREFERREDLIBS := $(OCAMLBYTECODELIBS)
else
	OCAMLOPT := $(OCAMLOPTEXE)
	OCAMLCOPT := $(OCAMLOPT)
	CMOX := cmx
	CMAX := cmxa
	ALLOPT := all.native
	TESTSOPT := tests.native
	OCAMLPREFERREDLIBS := $(OCAMLNATIVELIBS)
endif

ifeq (4.06.0,$(word 1,$(sort 4.06.0 $(OCAMLVERSION))))
	PYOPS=pyops
else
	PYOPS=
endif

MODULES := pyml_arch pyutils pytypes pywrappers py pycaml $(PYOPS)

VERSION := $(shell date "+%Y%m%d")

OCAMLLIBFLAGS := -cclib "-L. -lpyml_stubs"
OCAMLLIBNUMPYFLAGS := -cclib "-L. -lnumpy_stubs"

OCAMLLIBFLAGSNATIVE := $(OCAMLLIBFLAGS)
OCAMLLIBFLAGSBYTECODE := -custom $(OCAMLLIBFLAGS)

ARCH := $(shell uname)

ifeq ($(ARCH),Linux)
	PYML_ARCH := pyml_arch_linux.ml
else ifeq ($(ARCH),Darwin)
	PYML_ARCH := pyml_arch_darwin.ml
else ifeq ($(findstring CYGWIN,$(ARCH)),CYGWIN)
	PYML_ARCH := pyml_arch_cygwin.ml
else
	$(error Unsupported OS $(ARCH)
endif

INSTALL_FILES := \
	py.mli numpy.mli $(MODULES:=.cmi) $(MODULES:=.cmx) \
	numpy.cmi \
	pyml.cma pyml.cmxa pyml.cmxs pyml.a \
	numpy.cma numpy.cmxa numpy.cmxs numpy.a \
	libpyml_stubs.a dllpyml_stubs.so \
	libnumpy_stubs.a dllnumpy_stubs.so \
	META

.PHONY : all
all : all.bytecode $(ALLOPT)
	@echo The py.ml library is compiled.
	@echo Run \`make doc\' to build the documentation.
	@echo Run \`make tests\' to check the test suite.
ifneq ($(HAVE_OCAMLFIND),no)
	@echo Run \`make install\' to install the library via ocamlfind.
endif
	@echo Run \`make pymltop\' to build the toplevel.
ifneq ($(HAVE_UTOP),no)
	@echo Run \`make pymlutop\' to build the utop toplevel.
endif

.PHONY : help
help :
	@echo make [all] : build the library
	@echo make all.bytecode : build only the bytecode library
	@echo make all.native : build only the native library
	@echo make doc : build the documentation
ifneq ($(HAVE_OCAMLFIND),no)
	@echo make install : install the library via ocamlfind
endif
	@echo make clean : remove all the generated files
	@echo make tests : compile and run the test suite
	@echo make tests.bytecode : run only the bytecode version of the tests
	@echo make tests.native : run only the native version of the tests
	@echo make pymltop: build the toplevel
ifneq ($(HAVE_UTOP),no)
	@echo make pymlutop: build the utop toplevel.
endif
	@echo make HAVE_OCAMLFIND=no : disable ocamlfind
	@echo make HAVE_OCAMLOPT=no : disable ocamlopt
	@echo \
"make OCAMLC|OCAMLOPT|OCAMLMKLIB|OCAMLMKTOP|OCAMLDEP|OCAMLDOC=... :"
	@echo "  set paths to OCaml tools"
	@echo make OCAMLCFLAGS=... : set flags to OCaml compiler for compiling
	@echo make OCAMLLDFLAGS=... : set flags to OCaml compiler for linking
	@echo make OCAMLLIBFLAGS=... :
	@echo "  set flags to OCaml compiler for building the library"
	@echo make STDCOMPAT=... : set path to the stdcompat library

.PHONY : all.bytecode
all.bytecode : pyml.cma numpy.cma

.PHONY : all.native
all.native : pyml.cmxa pyml.cmxs numpy.cmxa numpy.cmxs

.PHONY : tests
tests : tests.bytecode $(TESTSOPT)

.PHONY : tests.bytecode
tests.bytecode : pyml_tests.bytecode numpy_tests.bytecode
	./pyml_tests.bytecode
	./numpy_tests.bytecode

.PHONY : tests.native
tests.native : pyml_tests.native numpy_tests.native
	./pyml_tests.native
	./numpy_tests.native

.PHONY : install
install : $(INSTALL_FILES)
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for 'make install')
endif
	$(OCAMLFIND) install pyml $(INSTALL_FILES)
	[ ! -f pymltop ] || $(INSTALL_PROGRAM) pymltop $(bindir)/pymltop
	[ ! -f pymlutop ] || $(INSTALL_PROGRAM) pymlutop $(bindir)/pymlutop

.PHONY : uninstall
uninstall :
	$(OCAMLFIND) remove pyml
	- rm $(bindir)/pymltop
	- rm $(bindir)/pymlutop

.PHONY : clean
clean :
	for module in $(MODULES) numpy generate pyml_tests_common pyml_tests \
		numpy_tests; do \
		rm -f $$module.cmi $$module.cmo $$module.cmx $$module.a \
			$$module.o; \
	done
	rm -f pyml.cma pyml.cmxa pyml.cmxs pyml.a
	rm -f numpy.cma numpy.cmxa numpy.cmxs numpy.a
	rm -f pywrappers.mli pywrappers.ml pyml_dlsyms.inc pyml_wrappers.inc
	rm -f pyml.h
	rm -f pyml_stubs.o dllpyml_stubs.so libpyml_stubs.a
	rm -f numpy_stubs.o dllnumpy_stubs.so libnumpy_stubs.a
	rm -f pyml_arch.ml
	rm -f generate pyml_tests.native pyml_tests.bytecode
	rm -f numpy_tests.native numpy_tests.bytecode
	rm -f .depend
	rm -rf doc
	rm -f pymltop pytop.cmo pymlutop pyutop.cmo
	rm -f pymltop_libdir.ml pymltop_libdir.cmo

.PHONY : tarball
tarball :
	git archive --format=tar.gz --prefix=pyml-$(VERSION)/ HEAD \
		>pyml-$(VERSION).tar.gz

doc : py.mli pycaml.mli numpy.mli pywrappers.ml
	mkdir -p $@
	$(OCAMLDOC) $(OCAMLCFLAGS) -html -d $@ $^
	touch $@

.depend : $(MODULES:=.ml) $(MODULES:=.mli) numpy.ml numpy.mli \
	pyml_tests_common.mli pyml_tests_common.ml pyml_tests.ml numpy_tests.ml
	$(OCAMLDEP) $^ >$@

ifneq ($(MAKECMDGOALS),clean)
-include .depend
endif

pyutils.cmo pyutils.cmx : pyutils.cmi

generate : pyutils.$(CMOX) generate.$(CMOX)
	$(OCAMLCOPT) $(OCAMLLDFLAGS) $(OCAMLPREFERREDLIBS) $^ -o $@

generate.cmo : generate.ml

generate.cmx : generate.ml

pywrappers.ml pyml_wrappers.inc : generate
	./generate

pyml_wrappers.inc : pywrappers.ml

pywrappers.mli : pywrappers.ml pytypes.cmi pyml_arch.cmi
	$(OCAMLC) -i $< >$@

pyml_tests.native : py.cmi pyml.cmxa pyml_tests_common.cmx pyml_tests.cmx
	$(OCAMLOPT) $(OCAMLLDFLAGS) $(OCAMLNATIVELIBS) pyml.cmxa \
		pyml_tests_common.cmx pyml_tests.cmx -o $@

pyml_tests.bytecode : py.cmi pyml.cma pyml_tests_common.cmo pyml_tests.cmo
	$(OCAMLC) $(OCAMLLDFLAGS) $(OCAMLBYTECODELIBS) pyml.cma \
		pyml_tests_common.cmo pyml_tests.cmo -o $@

numpy_tests.native : py.cmi pyml.cmxa numpy.cmxa \
		pyml_tests_common.cmx numpy_tests.cmx
	$(OCAMLOPT) $(OCAMLLDFLAGS) $(OCAMLNATIVELIBSNUMPY) \
		pyml.cmxa numpy.cmxa \
		pyml_tests_common.cmx numpy_tests.cmx -o $@

numpy_tests.bytecode : py.cmi pyml.cma numpy.cma \
		pyml_tests_common.cmo numpy_tests.cmo
	$(OCAMLC) $(OCAMLLDFLAGS) $(OCAMLBYTECODELIBSNUMPY) pyml.cma \
		numpy.cma pyml_tests_common.cmo numpy_tests.cmo -o $@

pyml_arch.ml : $(PYML_ARCH)
	cp $< $@

pyml_arch.cmo pyml_arch.cmx : pyml_arch.cmi

%.cmi : %.mli
	$(OCAMLC) $(OCAMLCFLAGS) -c $< -o $@

%.cmo : %.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c $< -o $@

%.cmx : %.ml
	$(OCAMLOPT) $(OCAMLCFLAGS) -c $< -o $@

%.o : %.c
	$(OCAMLC) -c $< -o $@

pyml_stubs.o : pyml_wrappers.inc

pyml.cma : $(MODULES:=.cmo) libpyml_stubs.a
	$(OCAMLC) $(OCAMLLIBFLAGSBYTECODE) -a $(MODULES:=.cmo) -o $@

pyml.cmxa : $(MODULES:=.cmx) libpyml_stubs.a
	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -a $(MODULES:=.cmx) -o $@

pyml.cmxs : $(MODULES:=.cmx) libpyml_stubs.a
	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -shared $(MODULES:=.cmx) -o $@

lib%.a : %.o
	$(OCAMLMKLIB) -o $(basename $<) $<

numpy.cma : numpy.cmo libnumpy_stubs.a
	$(OCAMLC) -custom $(OCAMLLIBNUMPYFLAGS) -a numpy.cmo -o $@

numpy.cmxa : numpy.cmx libnumpy_stubs.a
	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -a numpy.cmx -o $@

numpy.cmxs : numpy.cmx libnumpy_stubs.a
	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -shared numpy.cmx -o $@

pytop.cmo : pytop.ml pymltop_libdir.cmi
	$(OCAMLC) -I +compiler-libs -c $<

pymltop_libdir.ml :
	if [ -z "$(PREFIX)" ]; then \
	  echo "let libdir=\"$(PWD)\""; \
	else \
	  echo "let libdir=\"$(PREFIX)/lib/pyml/\""; \
	fi >$@

pymltop : pyml.cma numpy.cma pymltop_libdir.cmo pytop.cmo
	$(OCAMLMKTOP) $(OCAMLLDFLAGS) $(OCAMLLIBNUMPYFLAGS) $(OCAMLBYTECODELIBSNUMPY) $^ -o $@

pyutop.cmo : pyutop.ml
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for utop)
endif
	$(OCAMLC) $(OCAMLCFLAGS) -thread -package utop -c $< -o $@

pymlutop : pyml.cma numpy.cma pymltop_libdir.cmo pytop.cmo pyutop.cmo
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for utop)
endif
#	ocamlmktop raises "Warning 31". See https://github.com/diml/utop/issues/212
#	$(OCAMLMKTOP) -o $@ -thread -linkpkg -package utop -dontlink compiler-libs $^
	ocamlfind ocamlc -thread -linkpkg -linkall -predicates create_toploop \
		-package compiler-libs.toplevel,utop,stdcompat $^ -o $@

=== debian/changelog ===
pyml (20190626-2build1) focal; urgency=medium

  * No change rebuild against new ocaml ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 21 Feb 2020 01:33:48 +0000

pyml (20190626-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Mon, 06 Jan 2020 16:30:13 +0100

pyml (20190626-1) unstable; urgency=medium

  * Initial release (Closes: #886713)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 29 Dec 2019 08:34:19 +0100

=== debian/control ===
Source: pyml
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 ocaml-nox,
 ocaml-findlib,
 libstdcompat-ocaml-dev,
 dh-ocaml
Standards-Version: 4.4.1
Rules-Requires-Root: no
Section: ocaml
Homepage: https://github.com/thierry-martinez/pyml
Vcs-Git: https://salsa.debian.org/ocaml-team/pyml.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/pyml

Package: libpyml-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib, python3-dev
Description: OCaml bindings for Python (development)
 py.ml provides OCaml bindings for Python. This library subsumes the
 pycaml library. Bindings are split in three modules:
  * Py provides the initialization functions and some high-level
    bindings, with error handling and naming conventions closer to
    OCaml usages;
  * Pycaml provides a signature close to the old Pycaml module, so as
    to ease migration;
  * Pywrappers provides low-level bindings, which follow closely the
    conventions of the C bindings for Python. Submodules
    Pywrappers.Python2 and Pywrappers.Python3 contain version-specific
    bindings.
 .
 This package contains the development files.

Package: libpyml-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml bindings for Python (runtime)
 py.ml provides OCaml bindings for Python. This library subsumes the
 pycaml library. Bindings are split in three modules:
  * Py provides the initialization functions and some high-level
    bindings, with error handling and naming conventions closer to
    OCaml usages;
  * Pycaml provides a signature close to the old Pycaml module, so as
    to ease migration;
  * Pywrappers provides low-level bindings, which follow closely the
    conventions of the C bindings for Python. Submodules
    Pywrappers.Python2 and Pywrappers.Python3 contain version-specific
    bindings.
 .
 This package contains the runtime files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

DESTDIR=$(CURDIR)/debian/tmp

export OCAMLFIND_DESTDIR=$(DESTDIR)$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) all HAVE_OCAMLOPT=$(OCAML_HAVE_OCAMLOPT)

override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR) $(DESTDIR)$(OCAML_DLL_DIR) $(DESTDIR)/usr/bin
	$(MAKE) install "PREFIX=$(DESTDIR)/usr" HAVE_OCAMLOPT=$(OCAML_HAVE_OCAMLOPT)
	rm -f $(DESTDIR)$(OCAML_DLL_DIR)/*.so.owner

override_dh_missing:
	dh_missing --fail-missing

## pyml 20200518

=== Makefile ===
--- 
+++ 
@@ -91,7 +91,7 @@
 	CMOX := cmo
 	CMAX := cma
 	ALLOPT :=
-	TESTSOPT :=
+	TESTOPT :=
 	OCAMLPREFERREDLIBS := $(OCAMLBYTECODELIBS)
 else
 	OCAMLOPT := $(OCAMLOPTEXE)
@@ -99,7 +99,7 @@
 	CMOX := cmx
 	CMAX := cmxa
 	ALLOPT := all.native
-	TESTSOPT := tests.native
+	TESTOPT := test.native
 	OCAMLPREFERREDLIBS := $(OCAMLNATIVELIBS)
 endif
 
@@ -119,16 +119,18 @@
 OCAMLLIBFLAGSNATIVE := $(OCAMLLIBFLAGS)
 OCAMLLIBFLAGSBYTECODE := -custom $(OCAMLLIBFLAGS)
 
-ARCH := $(shell uname)
-
-ifeq ($(ARCH),Linux)
+UNAME_ARCH := $(shell uname)
+
+ifeq ($(UNAME_ARCH),Linux)
 	PYML_ARCH := pyml_arch_linux.ml
-else ifeq ($(ARCH),Darwin)
+else ifeq ($(UNAME_ARCH),Darwin)
 	PYML_ARCH := pyml_arch_darwin.ml
-else ifeq ($(findstring CYGWIN,$(ARCH)),CYGWIN)
+else ifeq ($(findstring CYGWIN,$(UNAME_ARCH)),CYGWIN)
 	PYML_ARCH := pyml_arch_cygwin.ml
-else
-	$(error Unsupported OS $(ARCH)
+else ifeq ($(UNAME_ARCH),FreeBSD)
+	PYML_ARCH := pyml_arch_freebsd.ml
+else
+	$(error Unsupported OS $(UNAME_ARCH))
 endif
 
 INSTALL_FILES := \
@@ -136,6 +138,7 @@
 	numpy.cmi \
 	pyml.cma pyml.cmxa pyml.cmxs pyml.a \
 	numpy.cma numpy.cmxa numpy.cmxs numpy.a \
+	$(MODULES:=.cmx) numpy.cmx \
 	libpyml_stubs.a dllpyml_stubs.so \
 	libnumpy_stubs.a dllnumpy_stubs.so \
 	META
@@ -144,7 +147,7 @@
 all : all.bytecode $(ALLOPT)
 	@echo The py.ml library is compiled.
 	@echo Run \`make doc\' to build the documentation.
-	@echo Run \`make tests\' to check the test suite.
+	@echo Run \`make test\' to check the test suite.
 ifneq ($(HAVE_OCAMLFIND),no)
 	@echo Run \`make install\' to install the library via ocamlfind.
 endif
@@ -187,16 +190,16 @@
 .PHONY : all.native
 all.native : pyml.cmxa pyml.cmxs numpy.cmxa numpy.cmxs
 
-.PHONY : tests
-tests : tests.bytecode $(TESTSOPT)
-
-.PHONY : tests.bytecode
-tests.bytecode : pyml_tests.bytecode numpy_tests.bytecode
+.PHONY : test
+test : test.bytecode $(TESTOPT)
+
+.PHONY : test.bytecode
+test.bytecode : pyml_tests.bytecode numpy_tests.bytecode
 	./pyml_tests.bytecode
 	./numpy_tests.bytecode
 
-.PHONY : tests.native
-tests.native : pyml_tests.native numpy_tests.native
+.PHONY : test.native
+test.native : pyml_tests.native numpy_tests.native
 	./pyml_tests.native
 	./numpy_tests.native
 
@@ -305,12 +308,12 @@
 	$(OCAMLOPT) $(OCAMLCFLAGS) -c $< -o $@
 
 %.o : %.c
-	$(OCAMLC) -c $< -o $@
+	$(OCAMLC) -package stdcompat -c $< -o $@
 
 pyml_stubs.o : pyml_wrappers.inc
 
 pyml.cma : $(MODULES:=.cmo) libpyml_stubs.a
-	$(OCAMLC) $(OCAMLLIBFLAGSBYTECODE) -a $(MODULES:=.cmo) -o $@
+	$(OCAMLC) $(OCAMLLIBFLAGSBYTECODE) -a -dllib -lpyml_stubs $(MODULES:=.cmo) -o $@
 
 pyml.cmxa : $(MODULES:=.cmx) libpyml_stubs.a
 	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -a $(MODULES:=.cmx) -o $@
@@ -322,7 +325,7 @@
 	$(OCAMLMKLIB) -o $(basename $<) $<
 
 numpy.cma : numpy.cmo libnumpy_stubs.a
-	$(OCAMLC) -custom $(OCAMLLIBNUMPYFLAGS) -a numpy.cmo -o $@
+	$(OCAMLC) $(OCAMLLIBNUMPYFLAGS) -a -dllib -lnumpy_stubs numpy.cmo -o $@
 
 numpy.cmxa : numpy.cmx libnumpy_stubs.a
 	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -a numpy.cmx -o $@

=== debian/changelog ===
pyml (20200518-2) unstable; urgency=medium

  * Run tests only on native architectures

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Aug 2020 00:03:36 +0200

pyml (20200518-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0

 -- Stéphane Glondu <glondu@debian.org>  Fri, 07 Aug 2020 16:10:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: pyml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  ocaml-nox,
  ocaml-findlib,
- libstdcompat-ocaml-dev,
+ libstdcompat-ocaml-dev (>= 13),
+ python3-dev,
  dh-ocaml
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Section: ocaml
 Homepage: https://github.com/thierry-martinez/pyml

=== debian/rules ===
--- 
+++ 
@@ -19,5 +19,9 @@
 	$(MAKE) install "PREFIX=$(DESTDIR)/usr" HAVE_OCAMLOPT=$(OCAML_HAVE_OCAMLOPT)
 	rm -f $(DESTDIR)$(OCAML_DLL_DIR)/*.so.owner
 
-override_dh_missing:
-	dh_missing --fail-missing
+override_dh_auto_test:
+ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
+	dh_auto_test
+endif
+
+override_dh_dwz:

=== debian/tests/control ===
Tests: hello
Depends: ocaml-nox, ocaml-findlib, libpyml-ocaml-dev, python3-dev

=== debian/watch ===
version=3
https://github.com/thierry-martinez/pyml/releases .*/archive/(.*)\.tar\.gz

## pyml 20211015

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,9 @@
 INSTALL := install
 INSTALL_PROGRAM := $(INSTALL)
 bindir := $(PREFIX)/bin
+
+C_COMPILER := $(shell ocamlc -config | grep '^native_c_compiler:' | cut -d ' ' -f 2)
+EXT_LIB := $(shell ocamlc -config | grep '^ext_lib:' | cut -d ' ' -f 2)
 
 HAVE_OCAMLFIND := $(shell \
 	if $(OCAMLFIND) query -help >/dev/null 2>&1; then \
@@ -64,8 +67,8 @@
 	OCAMLDEP := ocamldep
 	OCAMLDOC := ocamldoc
 	STDCOMPAT := .
-        OCAMLCFLAGS :=
-        OCAMLLDFLAGS :=
+        OCAMLCFLAGS := -I $(STDCOMPAT)
+        OCAMLLDFLAGS := -I $(STDCOMPAT)
 	OCAMLBYTECODELIBS := unix.cma stdcompat.cma
 	OCAMLBYTECODELIBSNUMPY := unix.cma stdcompat.cma bigarray.cma
 	OCAMLNATIVELIBS := unix.cmxa stdcompat.cmxa
@@ -119,28 +122,14 @@
 OCAMLLIBFLAGSNATIVE := $(OCAMLLIBFLAGS)
 OCAMLLIBFLAGSBYTECODE := -custom $(OCAMLLIBFLAGS)
 
-UNAME_ARCH := $(shell uname)
-
-ifeq ($(UNAME_ARCH),Linux)
-	PYML_ARCH := pyml_arch_linux.ml
-else ifeq ($(UNAME_ARCH),Darwin)
-	PYML_ARCH := pyml_arch_darwin.ml
-else ifeq ($(findstring CYGWIN,$(UNAME_ARCH)),CYGWIN)
-	PYML_ARCH := pyml_arch_cygwin.ml
-else ifeq ($(UNAME_ARCH),FreeBSD)
-	PYML_ARCH := pyml_arch_freebsd.ml
-else
-	$(error Unsupported OS $(UNAME_ARCH))
-endif
-
 INSTALL_FILES := \
 	py.mli numpy.mli $(MODULES:=.cmi) $(MODULES:=.cmx) \
 	numpy.cmi \
-	pyml.cma pyml.cmxa pyml.cmxs pyml.a \
-	numpy.cma numpy.cmxa numpy.cmxs numpy.a \
+	pyml.cma pyml.cmxa pyml.cmxs pyml$(EXT_LIB) \
+	numpy.cma numpy.cmxa numpy.cmxs numpy$(EXT_LIB) \
 	$(MODULES:=.cmx) numpy.cmx \
-	libpyml_stubs.a dllpyml_stubs.so \
-	libnumpy_stubs.a dllnumpy_stubs.so \
+	libpyml_stubs$(EXT_LIB) dllpyml_stubs.so \
+	libnumpy_stubs$(EXT_LIB) dllnumpy_stubs.so \
 	META
 
 .PHONY : all
@@ -222,22 +211,23 @@
 clean :
 	for module in $(MODULES) numpy generate pyml_tests_common pyml_tests \
 		numpy_tests; do \
-		rm -f $$module.cmi $$module.cmo $$module.cmx $$module.a \
+		rm -f $$module.cmi $$module.cmo $$module.cmx $$module$(EXT_LIB) \
 			$$module.o; \
 	done
-	rm -f pyml.cma pyml.cmxa pyml.cmxs pyml.a
-	rm -f numpy.cma numpy.cmxa numpy.cmxs numpy.a
+	rm -f pyml.cma pyml.cmxa pyml.cmxs pyml$(EXT_LIB)
+	rm -f numpy.cma numpy.cmxa numpy.cmxs numpy$(EXT_LIB)
 	rm -f pywrappers.mli pywrappers.ml pyml_dlsyms.inc pyml_wrappers.inc
 	rm -f pyml.h
-	rm -f pyml_stubs.o dllpyml_stubs.so libpyml_stubs.a
-	rm -f numpy_stubs.o dllnumpy_stubs.so libnumpy_stubs.a
-	rm -f pyml_arch.ml
+	rm -f pyml_stubs.o dllpyml_stubs.so libpyml_stubs$(EXT_LIB)
+	rm -f numpy_stubs.o dllnumpy_stubs.so libnumpy_stubs$(EXT_LIB)
+	rm -f pyml_arch_generate.exe pyml_arch.ml
 	rm -f generate pyml_tests.native pyml_tests.bytecode
 	rm -f numpy_tests.native numpy_tests.bytecode
 	rm -f .depend
 	rm -rf doc
 	rm -f pymltop pytop.cmo pymlutop pyutop.cmo
 	rm -f pymltop_libdir.ml pymltop_libdir.cmo
+	rm -f pyops.mli pyops.ml
 
 .PHONY : tarball
 tarball :
@@ -293,8 +283,11 @@
 	$(OCAMLC) $(OCAMLLDFLAGS) $(OCAMLBYTECODELIBSNUMPY) pyml.cma \
 		numpy.cma pyml_tests_common.cmo numpy_tests.cmo -o $@
 
-pyml_arch.ml : $(PYML_ARCH)
-	cp $< $@
+pyml_arch_generate.exe : pyml_arch_generate.c
+	$(C_COMPILER) $< -o $@
+
+pyml_arch.ml : pyml_arch_generate.exe
+	./pyml_arch_generate.exe
 
 pyml_arch.cmo pyml_arch.cmx : pyml_arch.cmi
 
@@ -308,29 +301,29 @@
 	$(OCAMLOPT) $(OCAMLCFLAGS) -c $< -o $@
 
 %.o : %.c
-	$(OCAMLC) -package stdcompat -c $< -o $@
+	$(OCAMLC) $(OCAMLCFLAGS) -c $< -o $@
 
 pyml_stubs.o : pyml_wrappers.inc
 
-pyml.cma : $(MODULES:=.cmo) libpyml_stubs.a
+pyml.cma : $(MODULES:=.cmo) libpyml_stubs$(EXT_LIB)
 	$(OCAMLC) $(OCAMLLIBFLAGSBYTECODE) -a -dllib -lpyml_stubs $(MODULES:=.cmo) -o $@
 
-pyml.cmxa : $(MODULES:=.cmx) libpyml_stubs.a
+pyml.cmxa : $(MODULES:=.cmx) libpyml_stubs$(EXT_LIB)
 	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -a $(MODULES:=.cmx) -o $@
 
-pyml.cmxs : $(MODULES:=.cmx) libpyml_stubs.a
+pyml.cmxs : $(MODULES:=.cmx) libpyml_stubs$(EXT_LIB)
 	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -shared $(MODULES:=.cmx) -o $@
 
-lib%.a : %.o
+lib%$(EXT_LIB) : %.o
 	$(OCAMLMKLIB) -o $(basename $<) $<
 
-numpy.cma : numpy.cmo libnumpy_stubs.a
+numpy.cma : numpy.cmo libnumpy_stubs$(EXT_LIB)
 	$(OCAMLC) $(OCAMLLIBNUMPYFLAGS) -a -dllib -lnumpy_stubs numpy.cmo -o $@
 
-numpy.cmxa : numpy.cmx libnumpy_stubs.a
+numpy.cmxa : numpy.cmx libnumpy_stubs$(EXT_LIB)
 	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -a numpy.cmx -o $@
 
-numpy.cmxs : numpy.cmx libnumpy_stubs.a
+numpy.cmxs : numpy.cmx libnumpy_stubs$(EXT_LIB)
 	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -shared numpy.cmx -o $@
 
 pytop.cmo : pytop.ml pymltop_libdir.cmi
@@ -360,3 +353,9 @@
 #	$(OCAMLMKTOP) -o $@ -thread -linkpkg -package utop -dontlink compiler-libs $^
 	ocamlfind ocamlc -thread -linkpkg -linkall -predicates create_toploop \
 		-package compiler-libs.toplevel,utop,stdcompat $^ -o $@
+
+pyops.ml: pyops.ml.new
+	cp $< $@
+
+pyops.mli: pyops.mli.new
+	cp $< $@

=== debian/changelog ===
pyml (20211015-1ubuntu2) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 25 Feb 2022 13:54:08 +0100

pyml (20211015-1ubuntu1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 25 Feb 2022 13:53:36 +0100

pyml (20211015-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:21:47 +0100

pyml (20211015-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * New upstream release
  * Bump Standards-Version to 4.6.0

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Stéphane Glondu <glondu@debian.org>  Mon, 29 Nov 2021 14:31:51 +0100

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml-nox,
- ocaml-findlib,
+ ocaml-dune,
  libstdcompat-ocaml-dev (>= 13),
  python3-dev,
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Section: ocaml
 Homepage: https://github.com/thierry-martinez/pyml

=== debian/watch ===
version=4
https://github.com/thierry-martinez/pyml/releases .*/([0-9.]+)\.tar\.gz

## pyml 20220325

=== Makefile ===
--- 
+++ 
@@ -220,7 +220,7 @@
 	rm -f pyml.h
 	rm -f pyml_stubs.o dllpyml_stubs.so libpyml_stubs$(EXT_LIB)
 	rm -f numpy_stubs.o dllnumpy_stubs.so libnumpy_stubs$(EXT_LIB)
-	rm -f pyml_arch_generate.exe pyml_arch.ml
+	rm -f pyml_arch.ml
 	rm -f generate pyml_tests.native pyml_tests.bytecode
 	rm -f numpy_tests.native numpy_tests.bytecode
 	rm -f .depend
@@ -283,11 +283,8 @@
 	$(OCAMLC) $(OCAMLLDFLAGS) $(OCAMLBYTECODELIBSNUMPY) pyml.cma \
 		numpy.cma pyml_tests_common.cmo numpy_tests.cmo -o $@
 
-pyml_arch_generate.exe : pyml_arch_generate.c
-	$(C_COMPILER) $< -o $@
-
-pyml_arch.ml : pyml_arch_generate.exe
-	./pyml_arch_generate.exe
+pyml_arch.ml : pyml_arch.ml.c
+	$(C_COMPILER) -E $< | sed '/^#/d' >$@
 
 pyml_arch.cmo pyml_arch.cmx : pyml_arch.cmi

=== debian/changelog ===
pyml (20220325-1) unstable; urgency=medium

  * Team upload
  * New upstream release. This release fixes a bug with character conversion
    (closes: #1009430).
  * Remove patch 0002-Fix-79-segfault-when-debug_build-true-is-passed-to-i
    which has been applied upstream.
  * Standards-Version 4.6.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Wed, 01 Jun 2022 21:54:04 +0200

pyml (20211015-2) unstable; urgency=medium

  * Fix segfault when ~debug_build:true is passed to initialize

 -- Stéphane Glondu <glondu@debian.org>  Mon, 21 Mar 2022 17:20:22 +0100

## pyml 20220905

=== Makefile ===
--- 
+++ 
@@ -36,12 +36,6 @@
 	OCAMLDEP := $(OCAMLFIND) ocamldep
 	OCAMLDOC := $(OCAMLFIND) ocamldoc
 	STDCOMPAT := $(shell $(OCAMLFIND) query stdcompat)
-        OCAMLCFLAGS := -package stdcompat
-        OCAMLLDFLAGS := -linkpkg
-	OCAMLBYTECODELIBS := -package unix,stdcompat
-	OCAMLBYTECODELIBSNUMPY := -package unix,stdcompat,bigarray
-	OCAMLNATIVELIBS := -package unix,stdcompat
-	OCAMLNATIVELIBSNUMPY := -package unix,stdcompat,bigarray
 else
 	OCAMLC := $(shell \
 		if ocamlc.opt -version >/dev/null 2>&1; then \
@@ -67,12 +61,41 @@
 	OCAMLDEP := ocamldep
 	OCAMLDOC := ocamldoc
 	STDCOMPAT := .
-        OCAMLCFLAGS := -I $(STDCOMPAT)
-        OCAMLLDFLAGS := -I $(STDCOMPAT)
-	OCAMLBYTECODELIBS := unix.cma stdcompat.cma
-	OCAMLBYTECODELIBSNUMPY := unix.cma stdcompat.cma bigarray.cma
-	OCAMLNATIVELIBS := unix.cmxa stdcompat.cmxa
-	OCAMLNATIVELIBSNUMPY := unix.cmxa stdcompat.cmxa bigarray.cmxa
+endif
+
+OCAMLVERSION := $(shell $(OCAMLC) -version)
+OCAMLVERSION_LIST := $(subst ., ,$(OCAMLVERSION))
+OCAMLVERSION_MAJOR := $(word 1,$(OCAMLVERSION_LIST))
+
+LIBRARIES := unix stdcompat
+
+ifeq ($(OCAMLVERSION_MAJOR),5)
+	LIBRARIES_NUMPY = $(LIBRARIES)
+	OCAMLCFLAGS = -I +unix
+else
+	LIBRARIES_NUMPY = $(LIBRARIES) bigarray
+endif
+
+null  :=
+space := $(null) #
+comma := ,
+
+ifneq ($(HAVE_OCAMLFIND),no)
+        OCAMLCFLAGS += -package stdcompat
+        OCAMLLDFLAGS += -linkpkg
+	PACKAGES := $(subst $(space),$(comma),$(LIBRARIES))
+	PACKAGES_NUMPY := $(subst $(space),$(comma),$(LIBRARIES_NUMPY))
+	OCAMLBYTECODELIBS := -package $(PACKAGES)
+	OCAMLBYTECODELIBSNUMPY := -package $(PACKAGES_NUMPY)
+	OCAMLNATIVELIBS := -package $(PACKAGES)
+	OCAMLNATIVELIBSNUMPY := -package $(PACKAGES_NUMPY)
+else
+        OCAMLCFLAGS += -I $(STDCOMPAT)
+        OCAMLLDFLAGS += -I $(STDCOMPAT)
+	OCAMLBYTECODELIBS := $(LIBRARIES:=.cma)
+	OCAMLBYTECODELIBSNUMPY := $(LIBRARIES_NUMPY:=.cma)
+	OCAMLNATIVELIBS := $(LIBRARIES:=.cmxa)
+	OCAMLNATIVELIBSNUMPY := $(LIBRARIES_NUMPY:=.cmxa)
 endif
 
 ifeq ($(wildcard $(STDCOMPAT)/stdcompat.cma),)
@@ -262,7 +285,7 @@
 pyml_wrappers.inc : pywrappers.ml
 
 pywrappers.mli : pywrappers.ml pytypes.cmi pyml_arch.cmi
-	$(OCAMLC) -i $< >$@
+	$(OCAMLC) $(OCAMLCFLAGS) -i $< >$@
 
 pyml_tests.native : py.cmi pyml.cmxa pyml_tests_common.cmx pyml_tests.cmx
 	$(OCAMLOPT) $(OCAMLLDFLAGS) $(OCAMLNATIVELIBS) pyml.cmxa \

=== debian/changelog ===
pyml (20220905-1) unstable; urgency=medium

  * New upstream release
  * Drop 0001-Use-dune-2.7.patch
  * Disable two failing testst (Closes: #1028869)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 23 Jan 2023 12:07:22 +0100

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
  Stéphane Glondu <glondu@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml-nox,
+ ocaml,
  ocaml-dune,
  libstdcompat-ocaml-dev (>= 13),
  python3-dev,
  dh-ocaml
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Section: ocaml
 Homepage: https://github.com/thierry-martinez/pyml

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

DESTDIR=$(CURDIR)/debian/tmp

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	dune clean

override_dh_auto_build:
	dune build -p pyml

override_dh_auto_install:
	dune install --destdir=$(DESTDIR) --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)
	rm -f $(DESTDIR)/usr/doc/*/LICENSE*

override_dh_auto_test:
	dune runtest -p pyml

## pyml 20231101

=== Makefile ===
--- 
+++ 
@@ -207,13 +207,13 @@
 
 .PHONY : test.bytecode
 test.bytecode : pyml_tests.bytecode numpy_tests.bytecode
-	./pyml_tests.bytecode
-	./numpy_tests.bytecode
+	./pyml_tests.bytecode $(TEST_OPTIONS)
+	./numpy_tests.bytecode $(TEST_OPTIONS)
 
 .PHONY : test.native
 test.native : pyml_tests.native numpy_tests.native
-	./pyml_tests.native
-	./numpy_tests.native
+	./pyml_tests.native $(TEST_OPTIONS)
+	./numpy_tests.native $(TEST_OPTIONS)
 
 .PHONY : install
 install : $(INSTALL_FILES)

=== debian/changelog ===
pyml (20231101-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Thu, 15 Feb 2024 03:43:49 +0100

pyml (20220905-3) unstable; urgency=medium

  * Include ocamlvars.mk in debian/rules

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Jul 2023 07:02:14 +0200

pyml (20220905-2) unstable; urgency=medium

  * Use ocaml_dune DH buildsystem

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jul 2023 12:01:46 +0200

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,8 @@
  ocaml-dune,
  libstdcompat-ocaml-dev (>= 13),
  python3-dev,
- dh-ocaml
-Standards-Version: 4.6.1
+ dh-ocaml (>= 1.2)
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Section: ocaml
 Homepage: https://github.com/thierry-martinez/pyml

=== debian/watch ===
version=4
opts="searchmode=plain" \
https://api.github.com/repos/thierry-martinez/pyml/releases?per_page=50 \
https://github.com/thierry-martinez/pyml/releases/download/[^/]+/pyml\.@ANY_VERSION@\.tar\.gz

## pyml 20250807

=== debian/changelog ===
pyml (20250807-1build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Dec 2025 09:59:44 +0100

pyml (20250807-1) unstable; urgency=medium

  * New upstream release
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Fri, 19 Dec 2025 11:31:58 +0100

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,7 @@
  libstdcompat-ocaml-dev (>= 13),
  python3-dev,
  dh-ocaml (>= 1.2)
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Section: ocaml
 Homepage: https://github.com/thierry-martinez/pyml
 Vcs-Git: https://salsa.debian.org/ocaml-team/pyml.git
